library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.sys_regs_pkg.all;
use work.fitness_pkg.all;

entity ca_tb is end ca_tb;

architecture testbench of ca_tb is
	signal clk, reset : std_logic;
    signal best   : natural;
    signal func   : fitness_function;
    signal evolve : std_logic;

	constant clk_period : time := 1 ns;

    signal i, o : std_logic_vector(7 downto 0);
begin
    CA : entity work.ca
    generic map (
        width  => 8,
        height => 8
    )
    port map (
        clk   => clk,
        reset => reset,
        i     => i,
        o     => o,
        evolve => evolve,
        best => best,
        func => func
    );

    i <= x"a5";
    func <= FIT_2;
    evolve <= '1';

	-- Clock process
	clk_proc : process
	begin
		clk <= '1';
		wait for clk_period / 2;
		clk <= '0';
		wait for clk_period / 2;
	end process;

    process
    begin
        reset <= '1';
        wait for clk_period * 50;
        reset <= '0';
        wait;
    end process;
end testbench;
