library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity demux_tb is end demux_tb;

architecture testbench of demux_tb is
	signal clk, enable : std_logic;

	constant clk_period : time := 30 ns;

	signal m_single : std_logic;
	signal d_single : std_logic_vector(1 downto 0);

	signal m_bus : std_logic_vector(15 downto 0);
	signal d_bus : std_logic_vector(31 downto 0);
begin
	S: entity work.demux_single port map (clk, m_single, d_single);
	V: entity work.demux_vector generic map (length => 16) port map (clk, m_bus, d_bus);

	-- Clock process
	clk_proc : process
	begin
		clk <= '1';
		wait for clk_period / 2;
		clk <= '0';
		wait for clk_period / 2;
	end process;

	single_proc : process
	begin
		wait until clk = '0';
		wait for clk_period / 8;
		m_single <= '0';
		wait until clk = '1';
		wait for clk_period / 8;
		m_single <= '1';
	end process;

	bus_proc : process
	begin
		wait until clk = '1';
		wait for clk_period / 8;
		m_bus <= X"1234";
		wait until clk = '0';
		wait for clk_period / 8;
		m_bus <= X"5678";
	end process;

end testbench;
