library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity mux_tb is end mux_tb;

architecture testbench of mux_tb is
	signal clk, enable : std_logic;

	constant clk_period : time := 30 ns;

	signal m_single : std_logic;
	signal d_single : std_logic_vector(1 downto 0);

	signal m_bus : std_logic_vector(15 downto 0);
	signal d_bus : std_logic_vector(31 downto 0);
begin
	S: entity work.mux_single port map (clk, d_single, m_single);
	V: entity work.mux_vector generic map (length => 16) port map (clk, d_bus, m_bus);

	d_single <= b"10";
	d_bus <= X"12345678";

	-- Clock process
	clk_proc : process
	begin
		clk <= '1';
		wait for clk_period / 2;
		clk <= '0';
		wait for clk_period / 2;
	end process;
end testbench;
