library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity an128 is
    port (
        led : out std_logic_vector(7 downto 0);
        sw  : in  std_logic_vector(7 downto 0);
        clk : in  std_logic);
end an128;

architecture arch of an128 is
    signal count : unsigned(31 downto 0);
    signal add   : unsigned(7 downto 0);
begin
    process (clk)
    begin
        if rising_edge(clk) then
            count <= count + add;
        end if;
    end process;

    add <= unsigned(sw) + 1;
    led <= std_logic_vector(count(31 downto 24));
end arch;
