-----------------------------------------------------------------------------
-- Demultiplexers
-----------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;


entity demux_single is
	port (
		clk : in std_logic;
		i   : in std_logic;
		o   : out std_logic_vector(1 downto 0)
	);
end demux_single;

architecture demux_single_arch of demux_single is
    signal reg : std_logic;
begin
	process (clk, i) is
	begin
        if falling_edge(clk) then
            reg <= i;
		end if;
	end process;
    o(0) <= reg;
	o(1) <= i;
end demux_single_arch;

library ieee;
use ieee.std_logic_1164.all;


entity demux_vector is
	generic (
		length : integer
	);
	port (
		clk : in  std_logic;
		i   : in  std_logic_vector(length - 1 downto 0);
		o   : out std_logic_vector(length * 2 - 1 downto 0)
	);
end demux_vector;

architecture demux_vector_arch of demux_vector is

begin
	GEN: for j in 0 to (length - 1) generate
		S: entity work.demux_single
		port map(
			clk  => clk,
			i    => i(j),
			o(0) => o(j),
			o(1) => o(j + length)
		);
	end generate;
end demux_vector_arch;
