-----------------------------------------------------------------------------
-- Multiplexers
-----------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;


entity mux_single is
    port (
        clk : in  std_logic;
        i   : in  std_logic_vector(1 downto 0);
        o   : out std_logic
    );
end mux_single;

architecture mux_single_arch of mux_single is
--    signal reg : std_logic_vector(1 downto 0);
begin
    o <= i(0) when clk = '1' else i(1);
--    o <= reg(0) when clk = '1' else reg(1);
--    process (clk) is
--    begin
--        if rising_edge(clk) then
--            reg <= i;
--        end if;
--    end process;
end mux_single_arch;

library ieee;
use ieee.std_logic_1164.all;


entity mux_vector is
    generic (
        length : integer
    );
    port (
        clk : in  std_logic;
        i   : in  std_logic_vector(length * 2 - 1 downto 0);
        o   : out std_logic_vector(length - 1 downto 0)
    );
end mux_vector;

architecture mux_vector_arch of mux_vector is

begin
    GEN: for j in 0 to (length - 1) generate
        S: entity work.mux_single
        port map(
            clk  => clk,
            i(0) => i(j),
            i(1) => i(j + length),
            o    => o(j)
        );
    end generate;
end mux_vector_arch;
