#ifndef _CA_H_
#define _CA_H_

#include <stdint.h>
#include <stdio.h>

typedef uint32_t lut_t;
typedef struct ca_St ca_t;

ca_t *
ca_new(int w, int h);

void
ca_set_luts(ca_t *ca, const lut_t *luts);

uint32_t *
ca_run(ca_t *ca, uint32_t input, int iterations, uint8_t **states);

uint32_t *
ca_run_initial(ca_t *ca, uint32_t input, int iterations, uint8_t **states, uint8_t initial);

uint32_t *
ca_run_array(ca_t *ca, uint32_t *input, int iterations, uint8_t **states, uint8_t initial);

void
ca_anim(uint8_t *states, int w, int h, int iterations);

void
ca_dump(FILE *f, int prefix, uint8_t *states, int w, int h, int iterations);

void
ca_fft_init(void);

#endif /* _CA_H_ */
