#ifndef _EA_H_
#define _EA_H_

typedef struct {
	void *(*new)(void);
	void *(*copy)(void *);
	void *(*mutate)(void *genome);
	void (*crossover)(void *a, void *b, void **c, void **d);
	double (*calc_fitness)(void *genome, void *user_data);
	double (*distance)(void *a, void *b);

	void *user_data;
	double mut_rate;
	double cross_rate;
} ea_cfg_t;

typedef struct {
	double fit_best, fit_avg;
	double dist_avg, dist_var;
	void *gen_best;
	void **last_gen;
	double *last_fit;
} ea_result_t;

ea_result_t *
ea_one_plus_n(const ea_cfg_t *cfg, int n, int generations);
ea_result_t *
ea_one_plus_n_max(const ea_cfg_t *cfg, int n, int generations, double max);

ea_result_t *
ea_ga(const ea_cfg_t *cfg, int pop_size, int generations);

#endif /* _EA_H_ */
