#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ca.h"

#include "ea.h"
#define FIT_FUNC(o, i) (count_bits((o) ^ ((i) & 0xff)))

#define CA_W 8
#define CA_H 8

#include "util.h"

#define ITS 64

int
main(int argc, char *argv[])
{
	ls_genome_t *gen;
	int w, h;

	gen = ls_read(stdin, &w, &h);
	ls_dump(stdout, gen, w, h);

    uint32_t in[ITS];
	ca_t *ca;
    uint8_t *states;
    uint32_t *outs;

	ca_fft_init();

	FILE *graph = NULL;
	if (argc > 1) {
		graph = fopen(argv[1], "w");
	}

    ca = ca_new(w, h);
    ls_set_luts(ca, gen, w, h);

	for (int i = 0; i < 4; i++) {
		for (int j = 0; j < ITS; j++) {
			in[j] = (j / (1 << i) % 2) ? 0xff : 0x00;
		}

		outs = ca_run_array(ca, in, ITS, &states, gen->initial);
		if (graph == NULL)
			ca_anim(states, w, h, ITS);
		else
			ca_dump(graph, i + 1, states, w, h, ITS);
		free(outs);
		free(states);
	}

	if (graph != NULL) {
		int array[w * h];

		ls_run(gen, array, w, h);

		fprintf(graph, "\n\n# LS-img\n");
		for (int y = 0; y < h; y++) {
			for (int x = 0; x < w; x++) {
				fprintf(graph, "%i %i %i\n", x, y, array[x + y * w]);
			}
		}

		fclose(graph);
	}

    return 0;
}
