#include <stdio.h>
#include <stdlib.h>
#include "ca.h"

#define CA_W 8
#define CA_H 8

#define ITS 64

int
main(int argc, char *argv[])
{
	if (argc < 3) {
		fprintf(stderr,
		        "Too few arguments!\n"
		        "Usage: %s <LUT> <DUMP>\n",
		        argv[0]);
		exit(1);
	}

    uint32_t lut = strtol(argv[1], NULL, 0);
    uint32_t in[ITS];
	ca_t *ca;
    uint8_t *states;
    uint32_t *outs;
	lut_t luts[CA_W * CA_H];
	uint8_t input = strtol(argv[2], NULL, 0);

	for (int i = 0; i < CA_W * CA_H; i++) {
		luts[i] = lut;
	}

	ca_fft_init();

	FILE *graph = NULL;
	if (argc > 3)
		graph = fopen(argv[3], "w");

    ca = ca_new(CA_W, CA_H);
	ca_set_luts(ca, luts);

	for (int i = 0; i < 4; i++) {
		for (int j = 0; j < ITS; j++) {
			in[j] = (j / (1 << i) % 2) ? 0xff : 0x00;
		}

		outs = ca_run_array(ca, in, ITS, &states, input);
		if (graph == NULL)
			ca_anim(states, CA_W, CA_H, ITS);
		else
			ca_dump(graph, i + 1, states, CA_W, CA_H, ITS);
		free(outs);
		free(states);
	}

	if (graph != NULL)
		fclose(graph);
    return 0;
}
