import qualified Data.Vector.Unboxed as Vec
import Control.Arrow
import System.IO
import Statistics.Sample.KernelDensity
-- import Statistics.Sample.KernelDensity.Simple

getNums :: [Double] -> IO [Double]
getNums ds = do
    d <- fmap read getLine
    eof <- isEOF
    if eof
      then return (d:ds)
      else getNums (d:ds)

showPoint :: (Double, Double) -> String
showPoint (x, y) = show x ++ " " ++ show y ++ "\n"

main = do
    ds <- getNums []
    let points = uncurry Vec.zip $ kde 32 $ Vec.fromList ds
--    let points = uncurry Vec.zip $ first fromPoints $ gaussianPDF 128 $ Vec.fromList ds
        str = Vec.foldr ((++) . showPoint) "" points
    putStr str
