#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ca.h"

#include "ea.h"
#define FIT_FUNC(o, i) (count_bits((o) ^ ((i) & 0xff)))

#define CA_W 8
#define CA_H 8

#include "util.h"

#define ITS CA_W

static int goal_compact[] = { 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55 };

int
main(int argc, char *argv[])
{
	ls_genome_t *gen;
	int w, h;

	gen = ls_read(stdin, &w, &h);
	ls_dump(stdout, gen, w, h);

    uint32_t in[ITS];
	ca_t *ca;
    uint32_t *outs;
    uint8_t *states;
    int correct = 0;

	ca_fft_init();

	FILE *graph = NULL;
	if (argc > 1) {
		graph = fopen(argv[1], "w");
	}

    ca = ca_new(w, h);
    ls_set_luts(ca, gen, w, h);

	outs = ca_run_initial(ca, 0, ITS, &states, gen->initial);
	if (graph == NULL) {
		ca_anim(states, w, h, ITS);
	} else {
		ca_dump(graph, 1, states, w, h, ITS);
	}
	free(states);
	free(outs);

	if (graph != NULL) {
		int array[w * h];

		ls_run(gen, array, w, h);

		fprintf(graph, "\n\n# LS-img\n");
		for (int y = 0; y < h; y++) {
			for (int x = 0; x < w; x++) {
				fprintf(graph, "%i %i %i\n", x, y, array[x + y * w]);
			}
		}

		fclose(graph);
	}

    return 0;
}
