#include <stdio.h>
#include <stdlib.h>
#include "ca.h"

#define CA_W 8
#define CA_H 8

int
main(int argc, char *argv[])
{
	if (argc < 3) {
		fprintf(stderr,
		        "Too few arguments!\n"
		        "Usage: %s <LUT> <INPUT>\n",
		        argv[0]);
		exit(1);
	}

    uint32_t lut = strtol(argv[1], NULL, 0);
    uint32_t in  = strtol(argv[2], NULL, 0);
	ca_t *ca;
    uint8_t *states;
    uint32_t *outs;
	lut_t luts[CA_W * CA_H];

	ca_fft_init();

	for (int i = 0; i < CA_W * CA_H; i++) {
		luts[i] = lut;
	}

    ca = ca_new(CA_W, CA_H);
	ca_set_luts(ca, luts);
    outs = ca_run(ca, in, 128, &states);
    ca_anim(states, CA_W, CA_H, 128);

    free(outs);
    free(states);
    return 0;
}
